<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Image Slide</title>
    <script src="https://code.jquery.com/jquery-3.5.1.js"></script>
    <style>
        * { padding: 0%; margin: 0px;}
    </style>
</head>
<body>
    <div id="slide">
        <!-- 사진을 일렬로 세울때 li태그를 많이 사용한다. -->
        <ul>
            <li><img src="./image/01.jpg"></li>
            <li><img src="./image/02.jpg"></li>
            <li><img src="./image/03.jpg"></li>
            <li><img src="./image/04.jpg"></li>
            <li><img src="./image/05.jpg"></li>
            <li><img src="./image/06.jpg"></li>
            <li><img src="./image/07.jpg"></li>
        </ul>
    </div>
    <button class="prev">이전</button>
    <button class="next">다음</button>

    <script>
        // css를 제이쿼리로 넣기
        $("#slide").css({
            width: "690px",
            height: "350px",
            overflow: "hidden"  // 스크롤바가 사라지고 연결된 사진이 안보인다.
        });

        // list-style이 none이어야 이지마앞에 "점"이 사라진다.
        $("#slide ul").css({
            "list-style": "none",       
            "width": (690*7) + "px",    // 사진 7장의 폭
            "height": "350px"
        });

        // 이어진 사진을 옆으로 붙이기
        $("#slide ul li").css({
            "float": "left"             
        });

        // 왼쪽으로 스크롤하여 전 이미지로 넘기기
        $(".prev").on("click", function() {
            // 한번에 전 이미지로 넘어간다.
            // $("#slide").scrollLeft( $("#slide").scrollLeft() - 690 );

            // 스크롤이 현재에서 최종 690 만큼 움직이는 것을 기준으로 할당.
            // 스크롤 width가 실수일 경우 정수로 처리한다.
            var scrollTo = Math.round( $("#slide").scrollLeft() - 690 );
            // 스크롤 처음이 범위를 넘어가는 것을 방지한다.
            if ( scrollTo < 0 ) scrollTo = 0;

            // interval 사용하여 조금씩 이동하여 넘어가도록 한다.
            var timer = setInterval( function() {
                // 한번의 주기당 10씩 이동하도록 설정
                $("#slide").scrollLeft( $("#slide").scrollLeft() - 30 );
                if ( $("#slide").scrollLeft() <= scrollTo ) {
                    clearInterval( timer );
                };
            }, 10 ); // 초당 100번 주기로 돈다.
        });
        
        // 오른쪽으로 스크롤하여 다음 이미지로 넘기기
        $(".next").on("click", function() {
            // 한번에 다음 이미지로 넘어간다.
            // $("#slide").scrollLeft( $("#slide").scrollLeft() + 690 );

            // 스크롤이 현재에서 최종 690 만큼 움직이는 것을 기준으로 할당하며
            // 스크롤 width가 실수일 경우 정수로 처리한다.
            var scrollTo = Math.round( $("#slide").scrollLeft() + 690 );
            // 스크롤 마지막이 총길이보다 넘어가는 것을 방지한다.
            if ( scrollTo > ( 690 * 6 ) ) scrollTo = 690 * 6;

            // interval 사용하여 조금씩 이동하여 넘어가도록 한다.
            var timer = setInterval( function() {
                // 한번의 주기당 10씩 이동하도록 설정
                $("#slide").scrollLeft( $("#slide").scrollLeft() + 30 );
                if ( $("#slide").scrollLeft() >= scrollTo ) {
                    clearInterval( timer );
                };
            }, 10 ); // 초당 100번 주기로 돈다.
        });
        
    </script>
</body>
</html>